module Parser (parser, parse)
where
import Lexer
import Syntax
import Data.List

------------------------------------------------------------------------------------------------------------------------------------------------
-- module Parser performs the syntax analysis of a source program
-- the function parser is the core function in this module, its receives a source code as a string and returns a code of type Proc,
-- the function call is, for example: parser "<n> a ( <n> b ( <n> a1 (a <= \\ x -> x | a1 <h> b)))"
-- the file Parser.y contains a parser specification for further parser generation with Happy, the Haskell Parser Generator
-- the parser has the name parse and handles tokens of type Token
-- we specify here the context-free grammar of the calculu lambda(fchb) in accordance with dats structures described in the module Syntax
-- and some actions for its syntax 
------------------------------------------------------------------------------------------------------------------------------------------------

-- parser produced by Happy Version 1.17

data HappyAbsSyn t5 t6 t7 t8 t9 t10 t11
	= HappyTerminal Token
	| HappyErrorToken Int
	| HappyAbsSyn4 (Proc)
	| HappyAbsSyn5 t5
	| HappyAbsSyn6 t6
	| HappyAbsSyn7 t7
	| HappyAbsSyn8 t8
	| HappyAbsSyn9 t9
	| HappyAbsSyn10 t10
	| HappyAbsSyn11 t11

action_0 (13) = happyShift action_3
action_0 (31) = happyShift action_4
action_0 (41) = happyShift action_7
action_0 (4) = happyGoto action_5
action_0 (5) = happyGoto action_6
action_0 _ = happyFail

action_1 (13) = happyShift action_3
action_1 (31) = happyShift action_4
action_1 (5) = happyGoto action_2
action_1 _ = happyFail

action_2 (37) = happyShift action_9
action_2 _ = happyFail

action_3 (29) = happyShift action_11
action_3 (30) = happyShift action_12
action_3 (32) = happyShift action_13
action_3 (33) = happyShift action_14
action_3 (34) = happyShift action_15
action_3 (35) = happyShift action_16
action_3 (36) = happyShift action_17
action_3 _ = happyFail

action_4 (13) = happyShift action_10
action_4 _ = happyFail

action_5 (47) = happyAccept
action_5 _ = happyFail

action_6 (37) = happyShift action_9
action_6 _ = happyReduce_2

action_7 (13) = happyShift action_3
action_7 (31) = happyShift action_4
action_7 (41) = happyShift action_7
action_7 (4) = happyGoto action_8
action_7 (5) = happyGoto action_6
action_7 _ = happyFail

action_8 (42) = happyShift action_44
action_8 _ = happyFail

action_9 (13) = happyShift action_3
action_9 (31) = happyShift action_4
action_9 (41) = happyShift action_7
action_9 (4) = happyGoto action_43
action_9 (5) = happyGoto action_6
action_9 _ = happyFail

action_10 (41) = happyShift action_42
action_10 _ = happyFail

action_11 (12) = happyShift action_21
action_11 (13) = happyShift action_22
action_11 (14) = happyShift action_23
action_11 (15) = happyShift action_24
action_11 (16) = happyShift action_25
action_11 (18) = happyShift action_26
action_11 (20) = happyShift action_27
action_11 (21) = happyShift action_28
action_11 (22) = happyShift action_29
action_11 (23) = happyShift action_30
action_11 (24) = happyShift action_31
action_11 (25) = happyShift action_32
action_11 (26) = happyShift action_33
action_11 (27) = happyShift action_34
action_11 (28) = happyShift action_35
action_11 (41) = happyShift action_36
action_11 (44) = happyShift action_37
action_11 (6) = happyGoto action_41
action_11 (7) = happyGoto action_19
action_11 (8) = happyGoto action_20
action_11 _ = happyFail

action_12 (12) = happyShift action_21
action_12 (13) = happyShift action_22
action_12 (14) = happyShift action_23
action_12 (15) = happyShift action_24
action_12 (16) = happyShift action_25
action_12 (18) = happyShift action_26
action_12 (20) = happyShift action_27
action_12 (21) = happyShift action_28
action_12 (22) = happyShift action_29
action_12 (23) = happyShift action_30
action_12 (24) = happyShift action_31
action_12 (25) = happyShift action_32
action_12 (26) = happyShift action_33
action_12 (27) = happyShift action_34
action_12 (28) = happyShift action_35
action_12 (41) = happyShift action_36
action_12 (44) = happyShift action_37
action_12 (6) = happyGoto action_40
action_12 (7) = happyGoto action_19
action_12 (8) = happyGoto action_20
action_12 _ = happyFail

action_13 (12) = happyShift action_21
action_13 (13) = happyShift action_22
action_13 (14) = happyShift action_23
action_13 (15) = happyShift action_24
action_13 (16) = happyShift action_25
action_13 (18) = happyShift action_26
action_13 (20) = happyShift action_27
action_13 (21) = happyShift action_28
action_13 (22) = happyShift action_29
action_13 (23) = happyShift action_30
action_13 (24) = happyShift action_31
action_13 (25) = happyShift action_32
action_13 (26) = happyShift action_33
action_13 (27) = happyShift action_34
action_13 (28) = happyShift action_35
action_13 (41) = happyShift action_36
action_13 (44) = happyShift action_37
action_13 (6) = happyGoto action_39
action_13 (7) = happyGoto action_19
action_13 (8) = happyGoto action_20
action_13 _ = happyFail

action_14 (13) = happyShift action_38
action_14 _ = happyFail

action_15 (12) = happyShift action_21
action_15 (13) = happyShift action_22
action_15 (14) = happyShift action_23
action_15 (15) = happyShift action_24
action_15 (16) = happyShift action_25
action_15 (18) = happyShift action_26
action_15 (20) = happyShift action_27
action_15 (21) = happyShift action_28
action_15 (22) = happyShift action_29
action_15 (23) = happyShift action_30
action_15 (24) = happyShift action_31
action_15 (25) = happyShift action_32
action_15 (26) = happyShift action_33
action_15 (27) = happyShift action_34
action_15 (28) = happyShift action_35
action_15 (41) = happyShift action_36
action_15 (44) = happyShift action_37
action_15 (6) = happyGoto action_18
action_15 (7) = happyGoto action_19
action_15 (8) = happyGoto action_20
action_15 _ = happyFail

action_16 _ = happyReduce_11

action_17 _ = happyReduce_8

action_18 (12) = happyShift action_21
action_18 (13) = happyShift action_22
action_18 (14) = happyShift action_23
action_18 (15) = happyShift action_24
action_18 (16) = happyShift action_25
action_18 (18) = happyShift action_26
action_18 (20) = happyShift action_27
action_18 (21) = happyShift action_28
action_18 (22) = happyShift action_29
action_18 (23) = happyShift action_30
action_18 (24) = happyShift action_31
action_18 (25) = happyShift action_32
action_18 (26) = happyShift action_33
action_18 (27) = happyShift action_34
action_18 (28) = happyShift action_35
action_18 (41) = happyShift action_36
action_18 (44) = happyShift action_37
action_18 (7) = happyGoto action_46
action_18 (8) = happyGoto action_20
action_18 _ = happyReduce_10

action_19 _ = happyReduce_13

action_20 _ = happyReduce_27

action_21 _ = happyReduce_15

action_22 _ = happyReduce_14

action_23 _ = happyReduce_24

action_24 _ = happyReduce_25

action_25 _ = happyReduce_26

action_26 (12) = happyShift action_21
action_26 (13) = happyShift action_22
action_26 (14) = happyShift action_23
action_26 (15) = happyShift action_24
action_26 (16) = happyShift action_25
action_26 (18) = happyShift action_26
action_26 (20) = happyShift action_27
action_26 (21) = happyShift action_28
action_26 (22) = happyShift action_29
action_26 (23) = happyShift action_30
action_26 (24) = happyShift action_31
action_26 (25) = happyShift action_32
action_26 (26) = happyShift action_33
action_26 (27) = happyShift action_34
action_26 (28) = happyShift action_35
action_26 (41) = happyShift action_36
action_26 (44) = happyShift action_37
action_26 (7) = happyGoto action_52
action_26 (8) = happyGoto action_20
action_26 _ = happyFail

action_27 _ = happyReduce_29

action_28 _ = happyReduce_30

action_29 _ = happyReduce_31

action_30 _ = happyReduce_32

action_31 _ = happyReduce_33

action_32 _ = happyReduce_34

action_33 _ = happyReduce_35

action_34 (41) = happyShift action_51
action_34 _ = happyFail

action_35 (41) = happyShift action_50
action_35 _ = happyFail

action_36 (12) = happyShift action_21
action_36 (13) = happyShift action_22
action_36 (14) = happyShift action_23
action_36 (15) = happyShift action_24
action_36 (16) = happyShift action_25
action_36 (18) = happyShift action_26
action_36 (20) = happyShift action_27
action_36 (21) = happyShift action_28
action_36 (22) = happyShift action_29
action_36 (23) = happyShift action_30
action_36 (24) = happyShift action_31
action_36 (25) = happyShift action_32
action_36 (26) = happyShift action_33
action_36 (27) = happyShift action_34
action_36 (28) = happyShift action_35
action_36 (41) = happyShift action_36
action_36 (44) = happyShift action_37
action_36 (6) = happyGoto action_48
action_36 (7) = happyGoto action_49
action_36 (8) = happyGoto action_20
action_36 _ = happyFail

action_37 (13) = happyShift action_47
action_37 _ = happyFail

action_38 _ = happyReduce_7

action_39 (12) = happyShift action_21
action_39 (13) = happyShift action_22
action_39 (14) = happyShift action_23
action_39 (15) = happyShift action_24
action_39 (16) = happyShift action_25
action_39 (18) = happyShift action_26
action_39 (20) = happyShift action_27
action_39 (21) = happyShift action_28
action_39 (22) = happyShift action_29
action_39 (23) = happyShift action_30
action_39 (24) = happyShift action_31
action_39 (25) = happyShift action_32
action_39 (26) = happyShift action_33
action_39 (27) = happyShift action_34
action_39 (28) = happyShift action_35
action_39 (41) = happyShift action_36
action_39 (44) = happyShift action_37
action_39 (7) = happyGoto action_46
action_39 (8) = happyGoto action_20
action_39 _ = happyReduce_5

action_40 (12) = happyShift action_21
action_40 (13) = happyShift action_22
action_40 (14) = happyShift action_23
action_40 (15) = happyShift action_24
action_40 (16) = happyShift action_25
action_40 (18) = happyShift action_26
action_40 (20) = happyShift action_27
action_40 (21) = happyShift action_28
action_40 (22) = happyShift action_29
action_40 (23) = happyShift action_30
action_40 (24) = happyShift action_31
action_40 (25) = happyShift action_32
action_40 (26) = happyShift action_33
action_40 (27) = happyShift action_34
action_40 (28) = happyShift action_35
action_40 (41) = happyShift action_36
action_40 (44) = happyShift action_37
action_40 (7) = happyGoto action_46
action_40 (8) = happyGoto action_20
action_40 _ = happyReduce_9

action_41 (12) = happyShift action_21
action_41 (13) = happyShift action_22
action_41 (14) = happyShift action_23
action_41 (15) = happyShift action_24
action_41 (16) = happyShift action_25
action_41 (18) = happyShift action_26
action_41 (20) = happyShift action_27
action_41 (21) = happyShift action_28
action_41 (22) = happyShift action_29
action_41 (23) = happyShift action_30
action_41 (24) = happyShift action_31
action_41 (25) = happyShift action_32
action_41 (26) = happyShift action_33
action_41 (27) = happyShift action_34
action_41 (28) = happyShift action_35
action_41 (41) = happyShift action_36
action_41 (44) = happyShift action_37
action_41 (7) = happyGoto action_46
action_41 (8) = happyGoto action_20
action_41 _ = happyReduce_6

action_42 (13) = happyShift action_3
action_42 (31) = happyShift action_4
action_42 (41) = happyShift action_7
action_42 (4) = happyGoto action_45
action_42 (5) = happyGoto action_6
action_42 _ = happyFail

action_43 _ = happyReduce_1

action_44 _ = happyReduce_3

action_45 (42) = happyShift action_60
action_45 _ = happyFail

action_46 _ = happyReduce_12

action_47 (43) = happyShift action_59
action_47 _ = happyFail

action_48 (12) = happyShift action_21
action_48 (13) = happyShift action_22
action_48 (14) = happyShift action_23
action_48 (15) = happyShift action_24
action_48 (16) = happyShift action_25
action_48 (18) = happyShift action_26
action_48 (20) = happyShift action_27
action_48 (21) = happyShift action_28
action_48 (22) = happyShift action_29
action_48 (23) = happyShift action_30
action_48 (24) = happyShift action_31
action_48 (25) = happyShift action_32
action_48 (26) = happyShift action_33
action_48 (27) = happyShift action_34
action_48 (28) = happyShift action_35
action_48 (41) = happyShift action_36
action_48 (42) = happyShift action_58
action_48 (44) = happyShift action_37
action_48 (7) = happyGoto action_46
action_48 (8) = happyGoto action_20
action_48 _ = happyFail

action_49 (17) = happyShift action_56
action_49 (38) = happyShift action_57
action_49 _ = happyReduce_13

action_50 (12) = happyShift action_21
action_50 (13) = happyShift action_22
action_50 (14) = happyShift action_23
action_50 (15) = happyShift action_24
action_50 (16) = happyShift action_25
action_50 (18) = happyShift action_26
action_50 (20) = happyShift action_27
action_50 (21) = happyShift action_28
action_50 (22) = happyShift action_29
action_50 (23) = happyShift action_30
action_50 (24) = happyShift action_31
action_50 (25) = happyShift action_32
action_50 (26) = happyShift action_33
action_50 (27) = happyShift action_34
action_50 (28) = happyShift action_35
action_50 (41) = happyShift action_36
action_50 (44) = happyShift action_37
action_50 (7) = happyGoto action_55
action_50 (8) = happyGoto action_20
action_50 _ = happyFail

action_51 (12) = happyShift action_21
action_51 (13) = happyShift action_22
action_51 (14) = happyShift action_23
action_51 (15) = happyShift action_24
action_51 (16) = happyShift action_25
action_51 (18) = happyShift action_26
action_51 (20) = happyShift action_27
action_51 (21) = happyShift action_28
action_51 (22) = happyShift action_29
action_51 (23) = happyShift action_30
action_51 (24) = happyShift action_31
action_51 (25) = happyShift action_32
action_51 (26) = happyShift action_33
action_51 (27) = happyShift action_34
action_51 (28) = happyShift action_35
action_51 (41) = happyShift action_36
action_51 (44) = happyShift action_37
action_51 (7) = happyGoto action_54
action_51 (8) = happyGoto action_20
action_51 _ = happyFail

action_52 (19) = happyShift action_53
action_52 _ = happyFail

action_53 (39) = happyShift action_66
action_53 _ = happyFail

action_54 (38) = happyShift action_65
action_54 _ = happyFail

action_55 (38) = happyShift action_64
action_55 _ = happyFail

action_56 (12) = happyShift action_21
action_56 (13) = happyShift action_22
action_56 (14) = happyShift action_23
action_56 (15) = happyShift action_24
action_56 (16) = happyShift action_25
action_56 (18) = happyShift action_26
action_56 (20) = happyShift action_27
action_56 (21) = happyShift action_28
action_56 (22) = happyShift action_29
action_56 (23) = happyShift action_30
action_56 (24) = happyShift action_31
action_56 (25) = happyShift action_32
action_56 (26) = happyShift action_33
action_56 (27) = happyShift action_34
action_56 (28) = happyShift action_35
action_56 (41) = happyShift action_36
action_56 (44) = happyShift action_37
action_56 (7) = happyGoto action_63
action_56 (8) = happyGoto action_20
action_56 _ = happyFail

action_57 (12) = happyShift action_21
action_57 (13) = happyShift action_22
action_57 (14) = happyShift action_23
action_57 (15) = happyShift action_24
action_57 (16) = happyShift action_25
action_57 (18) = happyShift action_26
action_57 (20) = happyShift action_27
action_57 (21) = happyShift action_28
action_57 (22) = happyShift action_29
action_57 (23) = happyShift action_30
action_57 (24) = happyShift action_31
action_57 (25) = happyShift action_32
action_57 (26) = happyShift action_33
action_57 (27) = happyShift action_34
action_57 (28) = happyShift action_35
action_57 (41) = happyShift action_36
action_57 (44) = happyShift action_37
action_57 (7) = happyGoto action_62
action_57 (8) = happyGoto action_20
action_57 _ = happyFail

action_58 _ = happyReduce_28

action_59 (12) = happyShift action_21
action_59 (13) = happyShift action_22
action_59 (14) = happyShift action_23
action_59 (15) = happyShift action_24
action_59 (16) = happyShift action_25
action_59 (18) = happyShift action_26
action_59 (20) = happyShift action_27
action_59 (21) = happyShift action_28
action_59 (22) = happyShift action_29
action_59 (23) = happyShift action_30
action_59 (24) = happyShift action_31
action_59 (25) = happyShift action_32
action_59 (26) = happyShift action_33
action_59 (27) = happyShift action_34
action_59 (28) = happyShift action_35
action_59 (41) = happyShift action_36
action_59 (44) = happyShift action_37
action_59 (7) = happyGoto action_61
action_59 (8) = happyGoto action_20
action_59 _ = happyFail

action_60 _ = happyReduce_4

action_61 _ = happyReduce_16

action_62 (38) = happyShift action_78
action_62 (42) = happyShift action_79
action_62 _ = happyFail

action_63 (42) = happyShift action_77
action_63 _ = happyFail

action_64 (12) = happyShift action_21
action_64 (13) = happyShift action_22
action_64 (14) = happyShift action_23
action_64 (15) = happyShift action_24
action_64 (16) = happyShift action_25
action_64 (18) = happyShift action_26
action_64 (20) = happyShift action_27
action_64 (21) = happyShift action_28
action_64 (22) = happyShift action_29
action_64 (23) = happyShift action_30
action_64 (24) = happyShift action_31
action_64 (25) = happyShift action_32
action_64 (26) = happyShift action_33
action_64 (27) = happyShift action_34
action_64 (28) = happyShift action_35
action_64 (41) = happyShift action_36
action_64 (44) = happyShift action_37
action_64 (7) = happyGoto action_76
action_64 (8) = happyGoto action_20
action_64 _ = happyFail

action_65 (12) = happyShift action_21
action_65 (13) = happyShift action_22
action_65 (14) = happyShift action_23
action_65 (15) = happyShift action_24
action_65 (16) = happyShift action_25
action_65 (18) = happyShift action_26
action_65 (20) = happyShift action_27
action_65 (21) = happyShift action_28
action_65 (22) = happyShift action_29
action_65 (23) = happyShift action_30
action_65 (24) = happyShift action_31
action_65 (25) = happyShift action_32
action_65 (26) = happyShift action_33
action_65 (27) = happyShift action_34
action_65 (28) = happyShift action_35
action_65 (41) = happyShift action_36
action_65 (44) = happyShift action_37
action_65 (7) = happyGoto action_75
action_65 (8) = happyGoto action_20
action_65 _ = happyFail

action_66 (13) = happyShift action_70
action_66 (14) = happyShift action_71
action_66 (15) = happyShift action_72
action_66 (16) = happyShift action_73
action_66 (41) = happyShift action_74
action_66 (9) = happyGoto action_67
action_66 (10) = happyGoto action_68
action_66 (11) = happyGoto action_69
action_66 _ = happyFail

action_67 (40) = happyShift action_88
action_67 _ = happyFail

action_68 (38) = happyShift action_87
action_68 _ = happyReduce_36

action_69 (43) = happyShift action_86
action_69 _ = happyFail

action_70 (17) = happyShift action_85
action_70 _ = happyFail

action_71 _ = happyReduce_40

action_72 _ = happyReduce_39

action_73 _ = happyReduce_43

action_74 (13) = happyShift action_84
action_74 (14) = happyShift action_71
action_74 (15) = happyShift action_72
action_74 (16) = happyShift action_73
action_74 (41) = happyShift action_74
action_74 (11) = happyGoto action_83
action_74 _ = happyFail

action_75 (42) = happyShift action_82
action_75 _ = happyFail

action_76 (42) = happyShift action_81
action_76 _ = happyFail

action_77 _ = happyReduce_23

action_78 (12) = happyShift action_21
action_78 (13) = happyShift action_22
action_78 (14) = happyShift action_23
action_78 (15) = happyShift action_24
action_78 (16) = happyShift action_25
action_78 (18) = happyShift action_26
action_78 (20) = happyShift action_27
action_78 (21) = happyShift action_28
action_78 (22) = happyShift action_29
action_78 (23) = happyShift action_30
action_78 (24) = happyShift action_31
action_78 (25) = happyShift action_32
action_78 (26) = happyShift action_33
action_78 (27) = happyShift action_34
action_78 (28) = happyShift action_35
action_78 (41) = happyShift action_36
action_78 (44) = happyShift action_37
action_78 (7) = happyGoto action_80
action_78 (8) = happyGoto action_20
action_78 _ = happyFail

action_79 _ = happyReduce_20

action_80 (38) = happyShift action_94
action_80 (42) = happyShift action_95
action_80 _ = happyFail

action_81 _ = happyReduce_18

action_82 _ = happyReduce_17

action_83 (42) = happyShift action_93
action_83 _ = happyFail

action_84 (17) = happyShift action_85
action_84 (38) = happyShift action_92
action_84 _ = happyFail

action_85 (13) = happyShift action_91
action_85 _ = happyFail

action_86 (12) = happyShift action_21
action_86 (13) = happyShift action_22
action_86 (14) = happyShift action_23
action_86 (15) = happyShift action_24
action_86 (16) = happyShift action_25
action_86 (18) = happyShift action_26
action_86 (20) = happyShift action_27
action_86 (21) = happyShift action_28
action_86 (22) = happyShift action_29
action_86 (23) = happyShift action_30
action_86 (24) = happyShift action_31
action_86 (25) = happyShift action_32
action_86 (26) = happyShift action_33
action_86 (27) = happyShift action_34
action_86 (28) = happyShift action_35
action_86 (41) = happyShift action_36
action_86 (44) = happyShift action_37
action_86 (6) = happyGoto action_90
action_86 (7) = happyGoto action_19
action_86 (8) = happyGoto action_20
action_86 _ = happyFail

action_87 (13) = happyShift action_70
action_87 (14) = happyShift action_71
action_87 (15) = happyShift action_72
action_87 (16) = happyShift action_73
action_87 (41) = happyShift action_74
action_87 (9) = happyGoto action_89
action_87 (10) = happyGoto action_68
action_87 (11) = happyGoto action_69
action_87 _ = happyFail

action_88 _ = happyReduce_19

action_89 _ = happyReduce_37

action_90 (12) = happyShift action_21
action_90 (13) = happyShift action_22
action_90 (14) = happyShift action_23
action_90 (15) = happyShift action_24
action_90 (16) = happyShift action_25
action_90 (18) = happyShift action_26
action_90 (20) = happyShift action_27
action_90 (21) = happyShift action_28
action_90 (22) = happyShift action_29
action_90 (23) = happyShift action_30
action_90 (24) = happyShift action_31
action_90 (25) = happyShift action_32
action_90 (26) = happyShift action_33
action_90 (27) = happyShift action_34
action_90 (28) = happyShift action_35
action_90 (41) = happyShift action_36
action_90 (44) = happyShift action_37
action_90 (7) = happyGoto action_46
action_90 (8) = happyGoto action_20
action_90 _ = happyReduce_38

action_91 _ = happyReduce_42

action_92 (13) = happyShift action_97
action_92 _ = happyFail

action_93 _ = happyReduce_41

action_94 (12) = happyShift action_21
action_94 (13) = happyShift action_22
action_94 (14) = happyShift action_23
action_94 (15) = happyShift action_24
action_94 (16) = happyShift action_25
action_94 (18) = happyShift action_26
action_94 (20) = happyShift action_27
action_94 (21) = happyShift action_28
action_94 (22) = happyShift action_29
action_94 (23) = happyShift action_30
action_94 (24) = happyShift action_31
action_94 (25) = happyShift action_32
action_94 (26) = happyShift action_33
action_94 (27) = happyShift action_34
action_94 (28) = happyShift action_35
action_94 (41) = happyShift action_36
action_94 (44) = happyShift action_37
action_94 (7) = happyGoto action_96
action_94 (8) = happyGoto action_20
action_94 _ = happyFail

action_95 _ = happyReduce_21

action_96 (42) = happyShift action_100
action_96 _ = happyFail

action_97 (38) = happyShift action_98
action_97 (42) = happyShift action_99
action_97 _ = happyFail

action_98 (13) = happyShift action_101
action_98 _ = happyFail

action_99 _ = happyReduce_44

action_100 _ = happyReduce_22

action_101 (38) = happyShift action_102
action_101 (42) = happyShift action_103
action_101 _ = happyFail

action_102 (13) = happyShift action_104
action_102 _ = happyFail

action_103 _ = happyReduce_45

action_104 (42) = happyShift action_105
action_104 _ = happyFail

action_105 _ = happyReduce_46

happyReduce_1 = happySpecReduce_3  4 happyReduction_1
happyReduction_1 (HappyAbsSyn4  happy_var_3)
	_
	(HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 (Parall happy_var_1 happy_var_3
	)
happyReduction_1 _ _ _  = notHappyAtAll 

happyReduce_2 = happySpecReduce_1  4 happyReduction_2
happyReduction_2 (HappyAbsSyn5  happy_var_1)
	 =  HappyAbsSyn4
		 (happy_var_1
	)
happyReduction_2 _  = notHappyAtAll 

happyReduce_3 = happySpecReduce_3  4 happyReduction_3
happyReduction_3 _
	(HappyAbsSyn4  happy_var_2)
	_
	 =  HappyAbsSyn4
		 (happy_var_2
	)
happyReduction_3 _ _ _  = notHappyAtAll 

happyReduce_4 = happyReduce 5 5 happyReduction_4
happyReduction_4 (_ `HappyStk`
	(HappyAbsSyn4  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 (New (mkV happy_var_2) happy_var_4
	) `HappyStk` happyRest

happyReduce_5 = happySpecReduce_3  5 happyReduction_5
happyReduction_5 (HappyAbsSyn6  happy_var_3)
	(HappyTerminal happy_var_2)
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Cell (mkV happy_var_1) (chkVal happy_var_2 happy_var_3)
	)
happyReduction_5 _ _ _  = notHappyAtAll 

happyReduce_6 = happySpecReduce_3  5 happyReduction_6
happyReduction_6 (HappyAbsSyn6  happy_var_3)
	_
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Thread (mkV happy_var_1) happy_var_3
	)
happyReduction_6 _ _ _  = notHappyAtAll 

happyReduce_7 = happySpecReduce_3  5 happyReduction_7
happyReduction_7 (HappyTerminal (TokVar _ happy_var_3))
	_
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Handle (mkV happy_var_1) (mkV happy_var_3)
	)
happyReduction_7 _ _ _  = notHappyAtAll 

happyReduce_8 = happySpecReduce_2  5 happyReduction_8
happyReduction_8 _
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Usedhandle (mkV happy_var_1)
	)
happyReduction_8 _ _  = notHappyAtAll 

happyReduce_9 = happySpecReduce_3  5 happyReduction_9
happyReduction_9 (HappyAbsSyn6  happy_var_3)
	_
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Lazythread (mkV happy_var_1) happy_var_3
	)
happyReduction_9 _ _ _  = notHappyAtAll 

happyReduce_10 = happySpecReduce_3  5 happyReduction_10
happyReduction_10 (HappyAbsSyn6  happy_var_3)
	(HappyTerminal happy_var_2)
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Buffer (mkV happy_var_1) (chkVal happy_var_2 happy_var_3)
	)
happyReduction_10 _ _ _  = notHappyAtAll 

happyReduce_11 = happySpecReduce_2  5 happyReduction_11
happyReduction_11 _
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn5
		 (Emptybuffer (mkV happy_var_1)
	)
happyReduction_11 _ _  = notHappyAtAll 

happyReduce_12 = happySpecReduce_2  6 happyReduction_12
happyReduction_12 (HappyAbsSyn7  happy_var_2)
	(HappyAbsSyn6  happy_var_1)
	 =  HappyAbsSyn6
		 (App happy_var_1 happy_var_2
	)
happyReduction_12 _ _  = notHappyAtAll 

happyReduce_13 = happySpecReduce_1  6 happyReduction_13
happyReduction_13 (HappyAbsSyn7  happy_var_1)
	 =  HappyAbsSyn6
		 (happy_var_1
	)
happyReduction_13 _  = notHappyAtAll 

happyReduce_14 = happySpecReduce_1  7 happyReduction_14
happyReduction_14 (HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn7
		 (V (mkV happy_var_1)
	)
happyReduction_14 _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_1  7 happyReduction_15
happyReduction_15 (HappyTerminal (TokInt _ happy_var_1))
	 =  HappyAbsSyn7
		 (mkInt happy_var_1
	)
happyReduction_15 _  = notHappyAtAll 

happyReduce_16 = happyReduce 4 7 happyReduction_16
happyReduction_16 ((HappyAbsSyn7  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (Lambda (mkV happy_var_2) happy_var_4
	) `HappyStk` happyRest

happyReduce_17 = happyReduce 6 7 happyReduction_17
happyReduction_17 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (Exch  happy_var_3 happy_var_5
	) `HappyStk` happyRest

happyReduce_18 = happyReduce 6 7 happyReduction_18
happyReduction_18 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (Put  happy_var_3 happy_var_5
	) `HappyStk` happyRest

happyReduce_19 = happyReduce 6 7 happyReduction_19
happyReduction_19 (_ `HappyStk`
	(HappyAbsSyn9  happy_var_5) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (Case happy_var_2 (chkAlts happy_var_5)
	) `HappyStk` happyRest

happyReduce_20 = happyReduce 5 7 happyReduction_20
happyReduction_20 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (pair  happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_21 = happyReduce 7 7 happyReduction_21
happyReduction_21 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (tupel3 happy_var_2 happy_var_4 happy_var_6
	) `HappyStk` happyRest

happyReduce_22 = happyReduce 9 7 happyReduction_22
happyReduction_22 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_8) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (tupel4 happy_var_2 happy_var_4 happy_var_6 happy_var_8
	) `HappyStk` happyRest

happyReduce_23 = happyReduce 5 7 happyReduction_23
happyReduction_23 (_ `HappyStk`
	(HappyAbsSyn7  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (cons happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_24 = happySpecReduce_1  7 happyReduction_24
happyReduction_24 _
	 =  HappyAbsSyn7
		 (false
	)

happyReduce_25 = happySpecReduce_1  7 happyReduction_25
happyReduction_25 _
	 =  HappyAbsSyn7
		 (true
	)

happyReduce_26 = happySpecReduce_1  7 happyReduction_26
happyReduction_26 _
	 =  HappyAbsSyn7
		 (nil
	)

happyReduce_27 = happySpecReduce_1  7 happyReduction_27
happyReduction_27 (HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn7
		 (happy_var_1
	)
happyReduction_27 _  = notHappyAtAll 

happyReduce_28 = happySpecReduce_3  7 happyReduction_28
happyReduction_28 _
	(HappyAbsSyn6  happy_var_2)
	_
	 =  HappyAbsSyn7
		 (happy_var_2
	)
happyReduction_28 _ _ _  = notHappyAtAll 

happyReduce_29 = happySpecReduce_1  8 happyReduction_29
happyReduction_29 _
	 =  HappyAbsSyn8
		 (CCell
	)

happyReduce_30 = happySpecReduce_1  8 happyReduction_30
happyReduction_30 _
	 =  HappyAbsSyn8
		 (CThread
	)

happyReduce_31 = happySpecReduce_1  8 happyReduction_31
happyReduction_31 _
	 =  HappyAbsSyn8
		 (CHandle
	)

happyReduce_32 = happySpecReduce_1  8 happyReduction_32
happyReduction_32 _
	 =  HappyAbsSyn8
		 (CLazy
	)

happyReduce_33 = happySpecReduce_1  8 happyReduction_33
happyReduction_33 _
	 =  HappyAbsSyn8
		 (CUnit
	)

happyReduce_34 = happySpecReduce_1  8 happyReduction_34
happyReduction_34 _
	 =  HappyAbsSyn8
		 (CBuffer
	)

happyReduce_35 = happySpecReduce_1  8 happyReduction_35
happyReduction_35 _
	 =  HappyAbsSyn8
		 (CGet
	)

happyReduce_36 = happySpecReduce_1  9 happyReduction_36
happyReduction_36 (HappyAbsSyn10  happy_var_1)
	 =  HappyAbsSyn9
		 ([happy_var_1]
	)
happyReduction_36 _  = notHappyAtAll 

happyReduce_37 = happySpecReduce_3  9 happyReduction_37
happyReduction_37 (HappyAbsSyn9  happy_var_3)
	_
	(HappyAbsSyn10  happy_var_1)
	 =  HappyAbsSyn9
		 (happy_var_1 : happy_var_3
	)
happyReduction_37 _ _ _  = notHappyAtAll 

happyReduce_38 = happySpecReduce_3  10 happyReduction_38
happyReduction_38 (HappyAbsSyn6  happy_var_3)
	_
	(HappyAbsSyn11  happy_var_1)
	 =  HappyAbsSyn10
		 (happy_var_1 happy_var_3
	)
happyReduction_38 _ _ _  = notHappyAtAll 

happyReduce_39 = happySpecReduce_1  11 happyReduction_39
happyReduction_39 _
	 =  HappyAbsSyn11
		 (altTrue
	)

happyReduce_40 = happySpecReduce_1  11 happyReduction_40
happyReduction_40 _
	 =  HappyAbsSyn11
		 (altFalse
	)

happyReduce_41 = happySpecReduce_3  11 happyReduction_41
happyReduction_41 _
	(HappyAbsSyn11  happy_var_2)
	_
	 =  HappyAbsSyn11
		 (happy_var_2
	)
happyReduction_41 _ _ _  = notHappyAtAll 

happyReduce_42 = happySpecReduce_3  11 happyReduction_42
happyReduction_42 (HappyTerminal (TokVar _ happy_var_3))
	_
	(HappyTerminal (TokVar _ happy_var_1))
	 =  HappyAbsSyn11
		 (chkAltCons (mkV happy_var_1) (mkV happy_var_3)
	)
happyReduction_42 _ _ _  = notHappyAtAll 

happyReduce_43 = happySpecReduce_1  11 happyReduction_43
happyReduction_43 _
	 =  HappyAbsSyn11
		 (altNil
	)

happyReduce_44 = happyReduce 5 11 happyReduction_44
happyReduction_44 (_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn11
		 (chkAltPair (mkV happy_var_2) (mkV happy_var_4)
	) `HappyStk` happyRest

happyReduce_45 = happyReduce 7 11 happyReduction_45
happyReduction_45 (_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_6)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn11
		 (chkAlt3Tupel (mkV happy_var_2) (mkV happy_var_4) (mkV happy_var_6)
	) `HappyStk` happyRest

happyReduce_46 = happyReduce 9 11 happyReduction_46
happyReduction_46 (_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_8)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_6)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokVar _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn11
		 (chkAlt4Tupel (mkV happy_var_2) (mkV happy_var_4) (mkV happy_var_6) (mkV happy_var_8)
	) `HappyStk` happyRest

happyNewToken action sts stk [] =
	action 47 47 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	TokInt _ happy_dollar_dollar -> cont 12;
	TokVar _ happy_dollar_dollar -> cont 13;
	TokFalse _ -> cont 14;
	TokTrue _ -> cont 15;
	TokNil _ -> cont 16;
	TokCons _ -> cont 17;
	TokCase _ -> cont 18;
	TokOf _ -> cont 19;
	TokCCell _ -> cont 20;
	TokCThread _ -> cont 21;
	TokCHandle _ -> cont 22;
	TokCLazy _ -> cont 23;
	TokCUnit _ -> cont 24;
	TokCBuffer _ -> cont 25;
	TokCGet _ -> cont 26;
	TokExch _ -> cont 27;
	TokPut _ -> cont 28;
	TokThread _ -> cont 29;
	TokSusThread _ -> cont 30;
	TokNew _ -> cont 31;
	TokCell _ -> cont 32;
	TokHandle _ -> cont 33;
	TokBuffer _ -> cont 34;
	TokEmptyBuffer _ -> cont 35;
	TokUsedHandle _ -> cont 36;
	TokParall _ -> cont 37;
	TokComma _ -> cont 38;
	TokCBOpen _ -> cont 39;
	TokCBClose _ -> cont 40;
	TokBOpen _ -> cont 41;
	TokBClose _ -> cont 42;
	TokArrow _ -> cont 43;
	TokLam _ -> cont 44;
	TokEq _ -> cont 45;
	Error _ -> cont 46;
	_ -> happyError' (tk:tks)
	}

happyError_ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [Token] -> HappyIdentity a
happyError' = HappyIdentity . happyError

parse tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


---------------------------------------------------------------------------------
-- happyError reports when the syntax structure of a source program is incorrect
---------------------------------------------------------------------------------

happyError :: [Token] -> a
happyError xs = error $ "parse error!" ++ show xs

----------------------------------------------------------------------------------
-- now we define actions
----------------------------------------------------------------------------------
-- mkV is an id function for identifiers
----------------------------------------------------------------------------------

mkV = id

---------------------------------------------------------------------------------------------------------------------------------------------
-- all constructors and alternatives have the form Constr Int Int Int [Exp] and Alt Int Int Int [Var] Exp, respectevely
-- these integer parameters are : type, number of a construct or an alternative of the same type, and arity
---------------------------------------------------------------------------------------------------------------------------------------------

nil             = Constr 1 1 0 []
cons a b        = Constr 1 2 2 [a,b]
true            = Constr 2 1 0 []
false           = Constr 2 2 0 []
pair a b        = Constr 3 1 2 [a,b]
tupel3 a b c    = Constr 4 1 3 [a,b,c]
tupel4 a b c d  = Constr 5 1 4 [a,b,c,d]
zero            = Constr 6 1 0 []
one             = Constr 6 2 0 []
npair a b       = Constr 6 3 2 [a,b]


altNil             = Alt 1 1 0 []
altCons a b        = Alt 1 2 2 [a,b]
altTrue            = Alt 2 1 0 []
altFalse           = Alt 2 2 0 []
altPair a b        = Alt 3 1 2 [a,b]
alt3Tupel a b c    = Alt 4 1 3 [a,b,c]
alt4Tupel a b c d  = Alt 5 1 4 [a,b,c,d]
altZero            = Alt 6 1 0 []
altOne             = Alt 6 2 0 []
altNpair a b       = Alt 6 3 2 [a,b]

-----------------------------------------------------------------------------------------------------------------------------------------------
-- actions (functions) chkAlts, chkAltPairs, chkAltCons, chkAlt3Tupel, chkAlt4Tupel prove wether case-alternatives correct and exhaustive
----------------------------------------------------------------------------------------------------------------------------------------------- 

chkAlts alts = case alts of
            [] -> error "case without alternatives";
            [Alt 3 1 b v exp] -> [Alt 3 1 b (showVar b v) exp];
            [Alt 4 1 b v exp] -> [Alt 4 1 b (showVar b v) exp];
            [Alt 5 1 b v exp] -> [Alt 5 1 b (showVar b v) exp];
            [Alt 1 1 b v1 exp1, Alt 1 2 d v2 exp2] -> [Alt 1 1 b (showVar b v1) exp1, Alt 1 2 d (showVar d v2) exp2];
            [Alt 2 1 b v1 exp1, Alt 2 2 d v2 exp2] -> [Alt 2 1 b (showVar b v1) exp1, Alt 2 2 d (showVar d v2) exp2];
            [Alt 1 2 b v1 exp1, Alt 1 1 d v2 exp2] -> [Alt 1 1 d (showVar d v2) exp2, Alt 1 2 b (showVar b v1) exp1];
            [Alt 2 2 b v1 exp1, Alt 2 1 d v2 exp2] -> [Alt 2 1 d (showVar d v2) exp2, Alt 2 2 b (showVar b v1) exp1];
            otherwise -> error "Exeption: invalid or too many alternatives in the case pattern"


showVar b  v = if (chkVar v == True) && (b == length (v)) then v 
               else error ("Exeption: missing variable in the pattern")

chkVar [] = True
chkVar (x:xs) = if any (x==) xs then error ("Exeption: repeated variables in the pattern")
                  else chkVar(xs)


chkAltPair :: Var -> Var -> Exp -> Alts
chkAltPair a b exp = if not (a == b) then Alt 3 1 2 [a,b] exp
		      	     else error ("Exeption: repeated variables in the pattern")
			      
chkAltCons :: Var -> Var -> Exp -> Alts
chkAltCons a b exp = if not (a == b) then Alt 1 2 2 [a,b] exp 
				     else error ("Exeption: repeated variables in the pattern")

chkAlt3Tupel :: Var -> Var -> Var -> Exp -> Alts
chkAlt3Tupel a b c exp = if [a,b,c] == nub [a,b,c] then Alt 4 1 3 [a,b,c] exp
                             else error ("Exeption: repeated variables in the pattern")

chkAlt4Tupel :: Var -> Var -> Var -> Var -> Exp -> Alts
chkAlt4Tupel a b c d exp = if [a,b,c,d] == nub [a,b,c,d] then Alt 5 1 4 [a,b,c,d] exp
                             else error ("Exeption: repeated variables in the pattern")

-------------------------------------------------------------------------------------------------------
-- the action chkValue proves wether the expression is a value
-------------------------------------------------------------------------------------------------------

chkVal :: Token -> Exp -> Exp
chkVal a exp = case exp of
               V var  -> exp;
               Constr a b c d -> exp;
               Lambda a b -> exp;
               CCell -> exp;
               CThread -> exp;
               CLazy -> exp;
               CUnit -> exp;
               CHandle -> exp;
               otherwise -> error ("Check the value input at the position " ++ show (getPos a))

-------------------------------------------------------------------------------------------------------------------------------------------------------
-- mkInt performes a binary encoding  of integers, all integers must have the following form: Constr 6 3 2 [x:xs]; 
-- Constr 6 3 2 is a special pair , where x is either True (if an integer is positive) or False (if negative)(as Constr 2 1 0 [] or Constr 2 2 0 []),
-- and xs is a list of Zeros and Ones (also as constructors), i.e. a binary code of an integer
------------------------------------------------------------------------------------------------------------------------------------------------------- 

mkInt :: Integer -> Exp
mkInt x = let xplus = if (x >= 0) then x else (-x); ifpos = if(x >= 0) then 1 else 2  in  Constr 6 3 2 [Constr 2 ifpos 0 [], mkInt2 xplus]
mkInt2 :: Integer -> Exp
mkInt2 0 = Constr 1 2 2 [Constr 6 1 0 [], Constr 1 1 0 []]
mkInt2 1 = Constr 1 2 2 [Constr 6 2 0 [], Constr 1 1 0 []]
mkInt2 x = Constr 1 2 2 [Constr 6 (if (mod x 2) == 1 then 2 else 1) 0 [], mkInt2 (div x 2)]

-------------------------------------------------------------------------------------------------------------------------------------------------------
-- parser is the main function in this module, as already described above,
-- it binds the lexer (lexer) and the generated parser (parse) together and returnes a parsed input as a code of type Proc
-------------------------------------------------------------------------------------------------------------------------------------------------------

parser :: String -> Proc
parse :: [Token] -> Proc
parser = (parse . lexer)

-------------------------------------------------------------------------------------------------------------------------------------------------------
-- some tests 
-------------------------------------------------------------------------------------------------------------------------------------------------------

test_p1 = parser " a <= b"
test_p2 = parser " <n> x( <n> y( y <h> x))"
test_p3 = parser " <n> x( x <= case x of {True -> False, False -> True})"
test_p4 = parser " <n> x( x <= case x of {[] -> False})"
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 28 "templates/GenericTemplate.hs" #-}








{-# LINE 49 "templates/GenericTemplate.hs" #-}

{-# LINE 59 "templates/GenericTemplate.hs" #-}

{-# LINE 68 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	 (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 155 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
	 sts1@(((st1@(HappyState (action))):(_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where sts1@(((st1@(HappyState (action))):(_))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk





             new_state = action


happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 253 "templates/GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail  (1) tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
	action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 317 "templates/GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
